package cn.com.qmth.examcloud.core.questions.service;

import java.util.List;
import java.util.Map;
import java.util.Set;

import cn.com.qmth.examcloud.question.core.paper.DefaultPaper;
import cn.com.qmth.examcloud.question.core.question.DefaultQuestion;

/**
 * @author 		weiwenhai
 * @date 		2018.8.15
 * @company		qmth
 * @describle	调卷规则远程接口
 */
public interface ExtractConfigProviderService {

	/**
	 * 根据调卷规则抽取试卷
	 * @param req
	 * @return
	 */
	public Map<String, Object> getDefaultPaper(Long examId,String courseCode,String groupCode);
	
	/**
	 * 根据试题id获取试题
	 * @param exam_id
	 * @param course_code
	 * @param group_code
	 * @param questionId
	 * @return
	 */
	public DefaultQuestion getDefaultQuestion(Long examId,String courseCode,String groupCode,String questionId);
	
	/**
	 * 根据试卷id获取试卷
	 * @param paperId
	 * @return
	 */
	public DefaultPaper getBaseDefaultPaper(String paperId);
	
	/**
	 * 根据试题id集合获取试题对象集合
	 * @param questionIds
	 * @return
	 */
	public Map<String, DefaultQuestion> getDefaultQuestions(Set<String> questionIds);

	/**
	 * 根据试题id查询试题答案
	 * @param questionId
	 * @return
	 */
	public List<String> getAnswer(String questionId);
	
	/**
	 * 根据试卷id查询主观题与客观题数量
	 * @param paperId
	 * @return
	 */
	public String getQuestionStructure(String paperId) throws Exception;
}
