package cn.com.qmth.examcloud.core.questions.service.bean.dto;

import java.io.Serializable;

import cn.com.qmth.examcloud.core.questions.base.excel.ExcelProperty;

/**
 * @author  	chenken
 * @date    	2017年7月18日 上午10:51:54
 * @company 	QMTH
 * @description 主观题数据--用于Excel导出
 */
public class SubjectiveQuestionStructure implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1130718763453256519L;
	
	/**
	 * 课程Id
	 */
	private Long courseId;
	/**
	 * 课程代码
	 */
	@ExcelProperty(name="科目代码",index = 0)
	private String courseCode;
	/**
	 * 课程名称
	 */
	@ExcelProperty(name="科目名称",index = 1)
	private String courseName;
	/**
	 * 试卷名称
	 */
	@ExcelProperty(name="试卷名称",index = 2)
	private String paperName;
	
	/**
	 * 试卷类型
	 */
	@ExcelProperty(name="试卷类型",index = 3)
	private String paperType;
	/**
	 * 大题号
	 */
	@ExcelProperty(name="大题号",index = 4)
	private Integer sectionNum;
	/**
	 * 大题名称
	 */
	@ExcelProperty(name="大题名称",index = 5)
	private String sectionName;
	/**
	 * 小题号
	 */
	@ExcelProperty(name="小题号",index = 6)
	private Integer unitNum;
	/**
	 * 小题分数
	 */
	@ExcelProperty(name="满分",index = 7)
	private Double unitScore;
	
	public SubjectiveQuestionStructure(){}
	
	public SubjectiveQuestionStructure(PaperExp paperExp,PaperDetailExp paperDetailExp,PaperDetailUnitExp unit){
		this.courseCode = paperExp.getCourseNo();
		this.courseName = paperExp.getCourseName();
		this.sectionNum = paperDetailExp.getNumber();
		this.sectionName = paperDetailExp.getName();
		this.unitNum = unit.getNumber();
		this.unitScore = unit.getScore();
	}
	
	public SubjectiveQuestionStructure(PaperExp paperExp,PaperDetailExp paperDetailExp,PaperDetailUnitExp unit,String paperType){
		this.courseId = Long.valueOf(paperExp.getCourse().getId());
		this.paperName = paperExp.getName();
		this.paperType = paperType;
		this.courseCode = paperExp.getCourseNo();
		this.courseName = paperExp.getCourseName();
		this.sectionNum = paperDetailExp.getNumber();
		this.sectionName = paperDetailExp.getName();
		this.unitNum = unit.getNumber();
		this.unitScore = unit.getScore();
	}

	public Long getCourseId() {
		return courseId;
	}

	public void setCourseId(Long courseId) {
		this.courseId = courseId;
	}

	public String getCourseCode() {
		return courseCode;
	}

	public void setCourseCode(String courseCode) {
		this.courseCode = courseCode;
	}

	public String getCourseName() {
		return courseName;
	}

	public void setCourseName(String courseName) {
		this.courseName = courseName;
	}

	public String getPaperName() {
		return paperName;
	}

	public void setPaperName(String paperName) {
		this.paperName = paperName;
	}

	public String getPaperType() {
		return paperType;
	}

	public void setPaperType(String paperType) {
		this.paperType = paperType;
	}

	public Integer getSectionNum() {
		return sectionNum;
	}

	public void setSectionNum(Integer sectionNum) {
		this.sectionNum = sectionNum;
	}

	public String getSectionName() {
		return sectionName;
	}

	public void setSectionName(String sectionName) {
		this.sectionName = sectionName;
	}

	public Integer getUnitNum() {
		return unitNum;
	}

	public void setUnitNum(Integer unitNum) {
		this.unitNum = unitNum;
	}

	public Double getUnitScore() {
		return unitScore;
	}

	public void setUnitScore(Double unitScore) {
		this.unitScore = unitScore;
	}
	
}

