package cn.com.qmth.examcloud.core.questions.service.rpc;

import java.util.List;

import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import cn.com.qmth.examcloud.core.questions.base.core.ExamCourseDto;

/**
 * @author  	chenken
 * @date    	2017年7月18日 上午9:39:46
 * @company 	QMTH
 * @description ExamCourseClient.java
 */
@FeignClient(value = "ExamCloud-service-exam-work")
public interface ExamCourseClient {
	@RequestMapping(method = RequestMethod.GET, value = "${app.api.exam}/exam_course/marking")
	List<ExamCourseDto> findExamCourseByExamId(@RequestParam("exam_id") String examId);
	
	@RequestMapping(method = RequestMethod.GET, value = "${app.api.exam}/exam_course")
	String findPageExamCourse(@RequestParam("exam_id") Long examId,
										   @RequestParam(value = "course_code",required = false) String courseCode,
										   @RequestParam("cur_page") Integer  currentPage,
										   @RequestParam("page_size") Integer  pageSize,
										   @RequestParam(value = "course_level",required = false) String courseLevel);
}

